/*-------------------------------------------------------------------------+
|                                                                          |
| Copyright 2005-2011 The ConQAT Project                                   |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+-------------------------------------------------------------------------*/
package org.conqat.ide.commons.ui.jface;

import java.util.Map;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Content provider for maps.
 * 
 * @author deissenb
 * @author $Author: deissenb $
 * @version $Rev: 34252 $
 * @levd.rating GREEN Hash: 89AD60A6A861EA5C60C362DD496A98FA
 */
public class MapContentProvider implements IStructuredContentProvider {

	/**
	 * If the provided element is not a {@link Map} this returns
	 * <code>null</code>. Otherwise it returns the array representation of
	 * {@link Map#entrySet()}.
	 */
	public Object[] getElements(Object inputElement) {
		if (!(inputElement instanceof Map<?, ?>)) {
			return null;
		}
		return ((Map<?, ?>) inputElement).entrySet().toArray();
	}

	/** Empty implementation. */
	public void dispose() {
		// empty implementation
	}

	/** Empty implementation. */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		// empty implementation
	}
}